#!/usr/bin/env python3

import random
import subprocess
import matplotlib.pyplot as plt


def generate_request_sream(num_requests):
    return [random.randint(0,35) for x in range(0,num_requests)]

num_samples = 200
num_requests = 200
algorithms=['FIFO', 'SSTF', 'SATF']



for (rotate_speed, seek_speed) in [(1, 10), (10, 10), (10, 1)]:

    results = []
    for i in range(0, num_samples): 
        stream = generate_request_sream(num_requests)
        result = []
        for alg in algorithms:
            command_line = "./disk-modified.py -c -S " + str(seek_speed) + " -R " + str(rotate_speed) + " -p " + alg + " -a " + ",".join([str(x) for x in stream])
            p = subprocess.Popen(command_line, stdout=subprocess.PIPE, shell=True)
            (output, err) = p.communicate()
            p_status = p.wait()
            result.append(int(output.decode().split('\n')[-3].split(':')[-1]))
        results.append(result)
    
    # Sort results according to SATF
    results = sorted(results, key=lambda x:x[2])
    
    fig, ax = plt.subplots()
    ax.set_yscale('log')
    
    ax.plot(range(0,num_samples), [x[0] for x in results], 'or', label="FIFO")
    ax.plot(range(0,num_samples), [x[1] for x in results], 'ob', label="SSTF")
    ax.plot(range(0,num_samples), [x[2] for x in results], 'ok', label="SATF")
    
    ax.legend()
    ax.set(xlabel='Experiment', ylabel='Total time', title='')
    ax.grid()
    
    figname=f"disk_R_{rotate_speed}_S_{seek_speed}.png"
    print("Saving " + figname)
    fig.savefig(figname)
    
